#include "gnuchess.h"
#include <bios.h>

#define ALTX  0x2D00
#define CTRLH 0x08

int getstr(char *str) {
    int key, aKey = 0;
    int retval = 0;
    int idx = 0;            // makes ^H easier

    *str = '\0';            // start it off right
    while (aKey != '\r') {
        key = _bios_keybrd(_KEYBRD_READ);
        aKey = key & 0x007f;
        if (isalnum(aKey) || aKey == '-') {
            str[idx++] = aKey;
            putchar((char)aKey);
        } else if (aKey == CTRLH) {
            if (idx) {
                str[--idx] = '\0';
                putchar((char)aKey);
            }
        } else if (key == ALTX) {
            retval = EOF;
            break;
        }
    }

    str[idx] = '\0';
    return retval;
}
